#ifndef LCD_Serial_H
#define LCD_Serial_H
//------------------------------------------------------------------------------
#include "LCD_Serial_Prototypes.h"
#include "I2C.h"
#include "PCF8574.h"
//------------------------------------------------------------------------------
void LCD_init(char address)
{
  I2C_init(100000);    // Initialize I2C bus with clock frequency of 100kHz
  Expander_init(address);
  
  LCD_command(home);
  LCD_command(function_set);
  LCD_command(display_on);
  LCD_command(clear); 
}
//------------------------------------------------------------------------------
void LCD_data(char data)
{
  RS = 1;                        //Data register  ( Strings and characters ).
  LCD_transmit(data); 
}
//------------------------------------------------------------------------------
void LCD_command(char command)
{
  RS = 0;                        //Instruction register ( commands ).
  LCD_transmit(command); 
}
//------------------------------------------------------------------------------
void LCD_transmit(char data)
{
  LCD_sendNibble(data & 0xF0);     //Higher Nible
  LCD_sendNibble(data << 4);       //Lower Nible
}
//------------------------------------------------------------------------------
void LCD_string(char row, char col, char * text)
{
  LCD_command(RowAddr[row] + col);  
  while(*text)
  {
    LCD_data(*text++);
  }
}
//------------------------------------------------------------------------------
void LCD_sendNibble(char data)
{
  data = data + RS;
  //Enable is pulsed to latch the data
  Expander_write(data | EN_high);
  __delay_ms(5);
  Expander_write(data & EN_low);
}
//------------------------------------------------------------------------------
#endif